<?php

namespace Drupal\smartcat_translation_manager\Event;

use Symfony\Component\EventDispatcher\Event;
use Drupal\Core\Entity\EntityInterface;

/**
 * Wraps a node insertion demo event for event listeners.
 */
class EntityEvent extends Event {

  const ENTITY_INSERT = 'smartcat_translation_manager.entity.insert';
  const ENTITY_UPDATE = 'smartcat_translation_manager.entity.update';
  const ENTITY_DELETE = 'smartcat_translation_manager.entity.delete';

  /**
   * Node entity.
   *
   * @var \Drupal\Core\Entity\EntityInterface
   */
  protected $entity;

  /**
   * Constructs a node insertion demo event object.
   *
   * @param \Drupal\Core\Entity\EntityInterface $entity
   */
  public function __construct(EntityInterface $entity) {
    $this->entity = $entity;
  }

  /**
   * Get the inserted entity.
   *
   * @return \Drupal\Core\Entity\EntityInterface
   */
  public function getEntity() {
    return $this->entity;
  }

}
